
/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

< wxTutorial! Tutorial para el aprendizaje de las bibliotecas wxWidgets.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include "dimag.h"
#include "path.h"

enum ids {
  ID_LASTIMAGE,
  ID_NEXTIMAGE,
};

BEGIN_EVENT_TABLE(DialogImage, wxDialog)
EVT_BUTTON(ID_LASTIMAGE, DialogImage::OnLastImage)
EVT_BUTTON(ID_NEXTIMAGE, DialogImage::OnNextImage)
END_EVENT_TABLE()

DialogImage::DialogImage(wxWindow* parent, wxWindowID id, const wxString& title, size_t example):
  wxDialog(parent, id, title, wxDefaultPosition, wxSize(450,350))
{
  Centre();

  cancel = new wxButton(this, wxID_CANCEL, wxString::FromUTF8("Cerrar"), wxPoint(350,270));

  nexample = example;
  switch(example){
  case 0:
    nimag = 2; // nº imagenes
    break;
  case 1:
    nimag = 2;
    break;
  case 2:
    nimag = 2;
    break;
  case 3:
    nimag = 11; 
    break;
  }
  
  image = wxImage(350,240);
  wxInitAllImageHandlers();

  imagenow = 0+(nexample*10);
  image.LoadFile(Path::GetPathImage(imagenow));
#ifdef __WXMSW__
  image.Resize(wxSize(350,240), wxPoint(0,0));
#endif

  showimage = new wxStaticBitmap(this, wxID_ANY, wxBitmap(image), 
				 wxPoint(20,15), wxSize(350,240));

  textimage = new wxStaticText(this, wxID_ANY, Path::GetCaptionImage(imagenow),
			       wxPoint(30,280), wxSize(320,20), 
			       wxALIGN_CENTER | wxST_NO_AUTORESIZE);

  wxImage buttonimage = wxImage(48,48);
  buttonimage.LoadFile(Path::GetPathPicture(2));
  nextimage = new wxBitmapButton(this, ID_NEXTIMAGE, wxBitmap(buttonimage), wxPoint(381,40));
  buttonimage.LoadFile(Path::GetPathPicture(1));
  lastimage = new wxBitmapButton(this, ID_LASTIMAGE, wxBitmap(buttonimage), wxPoint(381,120));
}
  
void DialogImage::OnLastImage(wxCommandEvent& event)
{
  if(imagenow == 0 || imagenow == 10 || imagenow == 20 || imagenow == 30){
    imagenow = 10*nexample+nimag-1;
  }
  else
    imagenow--;

  LoadImage(imagenow);
}

void DialogImage::OnNextImage(wxCommandEvent& event)
{
  if(imagenow == 10*nexample+nimag-1){
    switch(nexample){
    case 0: imagenow = 0; break;
    case 1: imagenow = 10; break;
    case 2: imagenow = 20; break;
    case 3: imagenow = 30; break;
    }
  }
  else
    imagenow++;

  LoadImage(imagenow);
}
 
void DialogImage::LoadImage(size_t numimage)
{
#ifdef __WXMSW__
  image.LoadFile(wxString::FromUTF8("./contenido/plantilla.png"));
  showimage->SetBitmap(wxBitmap(image));+
#endif

  image.LoadFile(Path::GetPathImage(numimage));
  
#ifdef __WXMSW__
  image.Resize(wxSize(350,240), wxPoint(0,0));
#endif

  showimage->SetBitmap(wxBitmap(image));
  textimage->SetLabel(Path::GetCaptionImage(numimage));
}
